/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * Copyright (C) 2006-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://openbluesky.java.net
 * SCM: https://bitbucket.org/tidalwave/openbluesky-src
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.lookandfeel.ui.quaqua;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Paint;
import java.awt.geom.Rectangle2D;
import javax.swing.JComponent;
import ch.randelshofer.quaqua.QuaquaToolBarUI;
import it.tidalwave.netbeans.lookandfeel.LookAndFeel;
import javax.swing.UIManager;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
public class BMQuaquaToolBarUI extends QuaquaToolBarUI
  { 
    private final static int MARGIN = 4;
    
    private static BMQuaquaToolBarUI panelUI;
    
    private Font font;

    /***************************************************************************
     *
     *
     **************************************************************************/
    public static BMQuaquaToolBarUI createUI (final JComponent component) 
      {
        if (panelUI == null) 
          {
            panelUI = new BMQuaquaToolBarUI();
          }
        
        return panelUI;
      }    
    
    /***************************************************************************
     *
     *
     **************************************************************************/
//    public BMQuaquaToolBarUI()
//      {
//        BorderFactory.createEtchedBorder(Color.RED, Color.BLUE);        
//      }
    
    /***************************************************************************
     *
     *
     **************************************************************************/
    @Override
    public void paint (final Graphics g, final JComponent component)
      {
//        final Graphics2D g2 = (Graphics2D)g;
//        final Paint savePaint = g2.getPaint();
//        final Color color = UIManager.getColor(LookAndFeel.COLOR_FRAME_FOREGROUND);
//        final Color color1 = variant(color, 0.8);
//        final Color color2 = variant(color, 1/0.8);
//        final Color fontColor = variant(color, 1/0.6);
//        final GradientPaint paint = new GradientPaint(0, 0, color1, 0, component.getHeight(), color2);
//        g2.setPaint(paint);
//        g.fillRect(0, 0, component.getWidth(), component.getHeight());
//        g2.setPaint(savePaint);
//        
//        final String tag = System.getProperty("it.tidalwave.bluemarine.version");
//        
//        if (tag != null)
//          {
//            if (font == null)
//              {
//                font = new Font("Arial Narrow", Font.BOLD, (int)Math.round(component.getHeight() * 0.8));    
//              }
//            
//            g.setFont(font);
//            final FontMetrics metrics = g.getFontMetrics();
//            final Rectangle2D bounds = metrics.getStringBounds(tag, g);
//            final int x = component.getWidth() - (int)bounds.getWidth() - MARGIN;
//            int y = (component.getHeight() - (int)bounds.getHeight()) / 2;
//            g.setColor(fontColor);
//            y = MARGIN;
//            
//            if (component.getWidth() > bounds.getWidth() * 2)
//              {
//                g.drawString(tag, x, component.getHeight() - y);
//              }
//          }
      }

    /***************************************************************************
     *
     *
     **************************************************************************/
//    @Override
//    protected Border createRolloverBorder() 
//      {
//        return BorderFactory.createEtchedBorder(Color.RED, Color.BLUE);
//      }
    
    /***************************************************************************
     *
     *
     **************************************************************************/
    public static Color variant (final Color c, final double factor) 
      {
        return new Color(Math.min((int)(c.getRed() * factor), 255),
                         Math.min((int)(c.getGreen() * factor), 255),
                         Math.min((int)(c.getBlue() * factor), 255));
      }
  }
